#include "HelloApp.h"

// include ilixi widget headers
#include "ui/VBoxLayout.h"
#include "ui/Label.h"
#include "ui/GridLayout.h"
#include "ui/PushButton.h"
#include "ui/Line.h"

using namespace ilixi;

HelloApp::HelloApp(int argc, char* argv[]) :
  Application(argc, argv)
{
  // Set application layout.
  setLayout(new VBoxLayout());

  // Create a new label
  Label * label = new Label("Hello World!");

  // Add label to application's layout.
  // By doing so application owns label.
  // label will be automatically destroyed if application quits or we set a new layout to application.
  addWidget(label);

  Line* line = new Line();
  addWidget(line);

  GridLayout* gl = new GridLayout(3, 3);
  Frame* frame = new Frame();
  addWidget(frame);
  frame->setLayout(gl);
  frame->setMargin(10);

  PushButton* pb1 = new PushButton("PushButton 1");
  pb1->setVConstraint(NoConstraint);
  gl->addWidget(pb1, 0, 0, 2, 1);

  PushButton* pb2 = new PushButton("PushButton 2");
  //    pb2->setHorizontalConstraint(MinimumConstraint);
  pb2->setVConstraint(MinimumConstraint);

  gl->addWidget(pb2);

  PushButton* pb3 = new PushButton("PushButton 3");
  //  pb3->setVConstraint(NoConstraint);

  //  pb2->setMinimumSize(400, 30);
  //  pb3->setMinimumSize(260, 40);

  gl->addWidget(pb3);

  PushButton* pb4 = new PushButton("PushButton 4");
  pb4->setVConstraint(ExpandingConstraint);
  pb4->setHConstraint(ExpandingConstraint);
  gl->addWidget(pb4, 1, 1, 1, 2);

  PushButton* pb5 = new PushButton("PushButton 5");
  pb5->setVConstraint(NoConstraint);
  gl->addWidget(pb5);

  PushButton* pb6 = new PushButton("PushButton 6");
  pb1->setVConstraint(NoConstraint);
  gl->addWidget(pb6);
}

HelloApp::~HelloApp()
{
}
